zoukankan      html  css  js  c++  java
  • UVA 10739 String to Palindrome(dp)

    Problem H
    String to Palindrome

    Input: Standard Input

    Output: Standard Output

    Time Limit: 1 Second

    In this problem you are asked to convert a string into a palindrome with minimum number of operations. The operations are described below:

    Here you’d have the ultimate freedom. You are allowed to:

    • Add any character at any position
    • Remove any character from any position
    • Replace any character at any position with another character

    Every operation you do on the string would count for a unit cost. You’d have to keep that as low as possible.

    For example, to convert “abccda” you would need at least two operations if we allowed you only to add characters. But when you have the option to replace any character you can do it with only one operation. We hope you’d be able to use this feature to your advantage.

    Input

    The input file contains several test cases. The first line of the input gives you the number of test cases, T (1≤T≤10). Then T test cases will follow, each in one line. The input for each test case consists of a string containing lower case letters only. You can safely assume that the length of this string will not exceed 1000 characters.

    Output

    For each set of input print the test case number first. Then print the minimum number of characters needed to turn the given string into a palindrome.

    Sample Input                               Output for Sample Input

    6
    tanbirahmed
    shahriarmanzoor
    monirulhasan
    syedmonowarhossain
    sadrulhabibchowdhury
    mohammadsajjadhossain

    Case 1: 5

    Case 2: 7

    Case 3: 6

    Case 4: 8

    Case 5: 8

    Case 6: 8


    题意:给定一个字符串,可以进行添加,删除,和替换操作,求最少操作数使得该串变成回文串。

    思路:i,j作为字符串的头尾。添加和删除操作其实是一样的。所以只需要考虑2种状态的转移了。

    状态转移方程如果str[i] == str[j]则满足回文不用转换。dp[i][j] = dp[i + 1][j - 1]

    如果不相等:dp[i][j] = min(min(dp[i + 1][j], dp[i][j - 1]), dp[i + 1][j - 1]) + 1

    由于是递推。所以要从后往前。

    代码:

    #include <stdio.h>
    #include <string.h>
    
    int t, i, j, dp[1005][1005], len;
    char sb[1005];
    
    int min(int a, int b) {
    	return a < b ? a : b;
    }
    
    int main() {
    	scanf("%d%*c", &t);
    	int tt = 1;
    	while (t --) {
    		memset(dp, 0, sizeof(dp));
    		gets(sb);
    		len = strlen(sb);
    		for (i = len - 1; i >= 0; i --) {
    			for (j = i + 1; j < len; j ++) {
    				if (sb[i] == sb[j])
    					dp[i][j] = dp[i + 1][j - 1];
    				else
    					dp[i][j] = min(min(dp[i + 1][j], dp[i][j - 1]), dp[i + 1][j - 1]) + 1;
    			}
    		}
    		printf("Case %d: %d
    ", tt ++, dp[0][len - 1]);
    	}
    	return 0;
    }



  • 相关阅读:
    java 正则 二次转义
    HDU1789 Doing Homework again 【贪心】
    扣丁学堂笔记第22天多媒体播放
    [Python]BeautifulSoup—HTML解析包
    Android高级控件(三)——&#160;使用Google ZXing实现二维码的扫描和生成相关功能体系
    Business Process and SAP ERP
    HTML基础知识总结一
    控制器View是怎样创建的?
    cocos2d-x 3.0 场景切换特效汇总
    LeetCode 3Sum
  • 原文地址:https://www.cnblogs.com/pangblog/p/3315335.html
Copyright © 2011-2022 走看看